//
// Copyright 2007, Lowell Boggs Jr.
//
// This file or directory, containing source code for a computer program,
// is Copyrighted by Lowell Boggs, Jr.  987 Regency Drive, Lewisville
// TX (USA), 75067.  You may use, copy, modify, and distribute this
// source file without charge or obligation so long as you agree to
// the following:
//
//  1.  You must indemnify Lowell Boggs against any and all financial
//      obligations caused by its use, misuse, function, or malfunction.
//      Further, you acknowledge that there is no warranty of any kind,
//      whatsoever.
//
//  2.  You agree not to attempt to patent any portion of this original
//      work -- though you may attempt to patent your own extensions to
//      it if you so choose.
//
//  3.  You keep this copyright notice with the file and all copies
//      of the file and do not change it anyway except language translation.
//
// You are responsible for enforcing your own compliance with these
// conditions and may not use this source file if you cannot agree to the
// above terms and conditions.


#include <string>

struct TranslateSet
  //
  //.  A TranslateSet a 256 byte table that maps incoming character values
  //.  to outgoing character values.  The set is constructed from
  //.  a string that defines character ranges.  Characters in ranges that
  //.  are not mapped, become simple pass-throughs -- that is, if you don't
  //.  override the default mapping, each character maps to its own value.
  //.
  //.  To use the character set, given a character, you ask the character set
  //.  what the mapped value should be.
  //.
  //.  Character ranges are like those used by the 'tr' command.
  //
{

  unsigned char inset_[256];   // the translation table

  TranslateSet();

  TranslateSet(std::string const &inset, std::string const &outset);

  std::string translate(std::string const &input) const;
    //
    //.  Translate a string from what it is now to the mapped form
    //.  as defined by table_.

};
